diff -ruN tarsnap-autoconf-1.0.32/tar/chunks/chunks_delete.c tarsnap-autoconf-1.0.33/tar/chunks/chunks_delete.c
--- tarsnap-autoconf-1.0.32/tar/chunks/chunks_delete.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/chunks/chunks_delete.c	2012-08-10 00:05:23.000000000 -0700
@@ -12,7 +12,7 @@
 
 struct chunks_delete_internal {
 	RWHASHTAB * HT;			/* Hash table of struct chunkdata. */
-	struct chunkdata * dir;		/* On-disk directory entries. */
+	void * dir;			/* On-disk directory entries. */
 	char * path;			/* Path to cache directory. */
 	STORAGE_D * S;			/* Storage layer cookie. */
 	struct chunkstats stats_total;	/* All archives, w/ multiplicity. */
@@ -46,7 +46,7 @@
 
 	/* Read the existing chunk directory. */
 	if ((C->HT = chunks_directory_read(cachepath, &C->dir,
-	    &C->stats_unique, &C->stats_total, &C->stats_extra, 0)) == NULL)
+	    &C->stats_unique, &C->stats_total, &C->stats_extra, 0, 0)) == NULL)
 		goto err2;
 
 	/* Zero "new chunks" and "this tape" statistics. */
@@ -67,6 +67,18 @@
 }
 
 /**
+ * chunks_delete_getdirsz(C):
+ * Return the number of entries in the chunks directory associated with ${C}.
+ */
+size_t
+chunks_delete_getdirsz(CHUNKS_D * C)
+{
+
+	/* Get the value from the hash table. */
+	return (rwhashtab_getsize(C->HT));
+}
+
+/**
  * chunks_delete_chunk(C, hash):
  * Delete the chunk with HMAC ${hash} as part of the delete transaction
  * associated with the cookie ${C}.  Note that chunks are actually
@@ -85,14 +97,16 @@
 	}
 
 	/* Update statistics. */
-	chunks_stats_add(&C->stats_total, ch->len, ch->zlen, -1);
-	chunks_stats_add(&C->stats_tape, ch->len, ch->zlen, 1);
+	chunks_stats_add(&C->stats_total, ch->len,
+	    ch->zlen_flags & CHDATA_ZLEN, -1);
+	chunks_stats_add(&C->stats_tape, ch->len,
+	    ch->zlen_flags & CHDATA_ZLEN, 1);
 	ch->ncopies -= 1;
 
 	/* If the chunk is not marked as CHDATA_CTAPE... */
-	if ((ch->flags & CHDATA_CTAPE) == 0) {
+	if ((ch->zlen_flags & CHDATA_CTAPE) == 0) {
 		/* ... add that flag... */
-		ch->flags |= CHDATA_CTAPE;
+		ch->zlen_flags |= CHDATA_CTAPE;
 
 		/* ... decrement the reference counter... */
 		ch->nrefs -= 1;
@@ -100,9 +114,9 @@
 		/* ... and delete the chunk if the refcount is now zero. */
 		if (ch->nrefs == 0) {
 			chunks_stats_add(&C->stats_unique, ch->len,
-			    ch->zlen, -1);
+			    ch->zlen_flags & CHDATA_ZLEN, -1);
 			chunks_stats_add(&C->stats_freed, ch->len,
-			    ch->zlen, 1);
+			    ch->zlen_flags & CHDATA_ZLEN, 1);
 
 			if (storage_delete_file(C->S, 'c', hash))
 				goto err0;
diff -ruN tarsnap-autoconf-1.0.32/tar/chunks/chunks_directory.c tarsnap-autoconf-1.0.33/tar/chunks/chunks_directory.c
--- tarsnap-autoconf-1.0.32/tar/chunks/chunks_directory.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/chunks/chunks_directory.c	2012-08-10 00:05:23.000000000 -0700
@@ -59,7 +59,7 @@
 	/* Convert to on-disk format. */
 	memcpy(che.hash, ch->hash, 32);
 	le32enc(che.len, ch->len);
-	le32enc(che.zlen, ch->zlen);
+	le32enc(che.zlen, ch->zlen_flags & CHDATA_ZLEN);
 	le32enc(che.nrefs, ch->nrefs);
 	le32enc(che.ncopies, ch->ncopies);
 
@@ -84,7 +84,7 @@
 
 	(void)cookie; 	/* Unused. */
 
-	if (ch->flags & CHDATA_MALLOC)
+	if (ch->zlen_flags & CHDATA_MALLOC)
 		free(rec);
 
 	return (0);
@@ -92,7 +92,7 @@
 
 /**
  * chunks_directory_read(cachepath, dir, stats_unique, stats_all, stats_extra,
- *     mustexist):
+ *     mustexist, statstape):
  * Read stats_extra statistics (statistics on non-chunks which are stored)
  * and the chunk directory (if present) from "${cachepath}/directory" into
  * memory allocated and assigned to ${*dir}; and return a hash table
@@ -100,18 +100,20 @@
  * statistics for all the chunks listed in the directory (counting
  * multiplicity) and populate stats_unique with statistics reflecting the
  * unique chunks.  If ${mustexist}, error out if the directory does not exist.
+ * If ${statstape}, allocate struct chunkdata_statstape records instead.
  */
 RWHASHTAB *
-chunks_directory_read(const char * cachepath, struct chunkdata ** dir,
+chunks_directory_read(const char * cachepath, void ** dir,
     struct chunkstats * stats_unique, struct chunkstats * stats_all,
-    struct chunkstats * stats_extra, int mustexist)
+    struct chunkstats * stats_extra, int mustexist, int statstape)
 {
 	struct chunkdata_external che;
 	struct chunkstats_external cse;
 	struct stat sb;
 	RWHASHTAB * HT;
 	char * s;
-	struct chunkdata * p;
+	struct chunkdata * p = NULL;
+	struct chunkdata_statstape * ps = NULL;
 	FILE * f;
 	size_t numchunks;
 
@@ -177,19 +179,25 @@
 	    sizeof(struct chunkdata_external);
 
 	/* Make sure we don't get an integer overflow. */
-	if (numchunks >= SIZE_MAX / sizeof(struct chunkdata)) {
+	if (numchunks >= SIZE_MAX / sizeof(struct chunkdata_statstape)) {
 		warn0("on-disk directory is too large: %s", s);
 		goto err2;
 	}
 
 	/*
 	 * Allocate memory to ${*dir} large enough to store a struct
-	 * chunkdata for each struct chunkdata_external in
-	 * ${cachepath}/directory.
+	 * chunkdata or struct chunkdata_statstape for each struct
+	 * chunkdata_external in ${cachepath}/directory.
 	 */
-	if ((p = malloc(numchunks * sizeof(struct chunkdata))) == NULL)
+	if (statstape) {
+		ps = malloc(numchunks * sizeof(struct chunkdata_statstape));
+		*dir = ps;
+	} else {
+		p = malloc(numchunks * sizeof(struct chunkdata));
+		*dir = p;
+	}
+	if (*dir == NULL)
 		goto err2;
-	*dir = p;
 
 	/* Open the directory file. */
 	if ((f = fopen(s, "r")) == NULL) {
@@ -208,6 +216,10 @@
 
 	/* Read the chunk structures. */
 	for (; numchunks != 0; numchunks--) {
+		/* Set p to point at the struct chunkdata. */
+		if (statstape)
+			p = &ps->d;
+
 		/* Read the file one record at a time... */
 		if (fread(&che, sizeof(che), 1, f) != 1) {
 			warnp("fread(%s)", s);
@@ -217,27 +229,29 @@
 		/* ... creating struct chunkdata records... */
 		memcpy(p->hash, che.hash, 32);
 		p->len = le32dec(che.len);
-		p->zlen = le32dec(che.zlen);
+		p->zlen_flags = le32dec(che.zlen);
 		p->nrefs = le32dec(che.nrefs);
 		p->ncopies = le32dec(che.ncopies);
-		p->flags = 0;
 
 		/* ... inserting them into the hash table... */
 		if (rwhashtab_insert(HT, p))
 			goto err4;
 
 		/* ... and updating the statistics. */
-		chunks_stats_add(stats_unique, p->len, p->zlen, 1);
-		chunks_stats_add(stats_all, p->len, p->zlen, p->ncopies);
+		chunks_stats_add(stats_unique, p->len, p->zlen_flags, 1);
+		chunks_stats_add(stats_all, p->len, p->zlen_flags, p->ncopies);
 
 		/* Sanity check. */
-		if ((p->len == 0) || (p->zlen == 0) || (p->nrefs == 0)) {
+		if ((p->len == 0) || (p->zlen_flags == 0) || (p->nrefs == 0)) {
 			warn0("on-disk directory is corrupt: %s", s);
 			goto err4;
 		}
 
 		/* Move to next record. */
-		p++;
+		if (statstape)
+			ps++;
+		else
+			p++;
 	}
 	if (fclose(f)) {
 		warnp("fclose(%s)", s);
@@ -339,7 +353,7 @@
  * elements, and ${dir}.
  */
 void
-chunks_directory_free(RWHASHTAB * HT, struct chunkdata * dir)
+chunks_directory_free(RWHASHTAB * HT, void * dir)
 {
 
 	/* Free records in the hash table. */
diff -ruN tarsnap-autoconf-1.0.32/tar/chunks/chunks_internal.h tarsnap-autoconf-1.0.33/tar/chunks/chunks_internal.h
--- tarsnap-autoconf-1.0.32/tar/chunks/chunks_internal.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/chunks/chunks_internal.h	2012-08-10 00:05:23.000000000 -0700
@@ -9,19 +9,25 @@
 #include "rwhashtab.h"
 
 /* Chunk metadata structure was allocated by malloc(3). */
-#define	CHDATA_MALLOC	(1 << 0)
+#define	CHDATA_MALLOC	((uint32_t)(1) << 30)
 /* Chunk belongs to the current tape. */
-#define CHDATA_CTAPE	(1 << 1)
+#define CHDATA_CTAPE	((uint32_t)(1) << 31)
+#define CHDATA_FLAGS	(0xc0000000)
+#define CHDATA_ZLEN	(~CHDATA_FLAGS)
 
 /* In-core chunk metadata structure. */
 struct chunkdata {
 	uint8_t hash[32];	/* HMAC of chunk. */
-	size_t len;		/* Length of chunk. */
-	size_t zlen;		/* Compressed length of chunk. */
-	size_t nrefs;		/* Number of existing tapes using this. */
-	size_t ncopies;		/* Number of copies of this chunk. */
-	size_t ncopies_ctape;	/* Used by chunks_stats only. */
-	int flags;		/* See CHDATA_* flags. */
+	uint32_t len;		/* Length of chunk. */
+	uint32_t zlen_flags;	/* Compressed length of chunk | flags. */
+	uint32_t nrefs;		/* Number of existing tapes using this. */
+	uint32_t ncopies;	/* Number of copies of this chunk. */
+};
+
+/* In-core chunk metadata structure used by statstape. */
+struct chunkdata_statstape {
+	struct chunkdata d;
+	uint32_t ncopies_ctape;	/* Used by chunks_stats only. */
 };
 
 /* Chunk statistics structure. */
@@ -33,7 +39,7 @@
 
 /**
  * chunks_directory_read(cachepath, dir, stats_unique, stats_all, stats_extra,
- *     mustexist):
+ *     mustexist, statstape):
  * Read stats_extra statistics (statistics on non-chunks which are stored)
  * and the chunk directory (if present) from "${cachepath}/directory" into
  * memory allocated and assigned to ${*dir}; and return a hash table
@@ -41,9 +47,10 @@
  * statistics for all the chunks listed in the directory (counting
  * multiplicity) and populate stats_unique with statistics reflecting the
  * unique chunks.  If ${mustexist}, error out if the directory does not exist.
+ * If ${statstape}, allocate struct chunkdata_statstape records instead.
  */
-RWHASHTAB * chunks_directory_read(const char *, struct chunkdata **,
-    struct chunkstats *, struct chunkstats *, struct chunkstats *, int);
+RWHASHTAB * chunks_directory_read(const char *, void **,
+    struct chunkstats *, struct chunkstats *, struct chunkstats *, int, int);
 
 /**
  * chunks_directory_write(cachepath, HT, stats_extra, suff):
@@ -59,7 +66,7 @@
  * Free the hash table ${HT} of struct chunkdata records, all of its
  * elements, and ${dir}.
  */
-void chunks_directory_free(RWHASHTAB *, struct chunkdata *);
+void chunks_directory_free(RWHASHTAB *, void *);
 
 /**
  * chunks_directory_commit(cachepath, osuff, nsuff):
diff -ruN tarsnap-autoconf-1.0.32/tar/chunks/chunks_read.c tarsnap-autoconf-1.0.33/tar/chunks/chunks_read.c
--- tarsnap-autoconf-1.0.32/tar/chunks/chunks_read.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/chunks/chunks_read.c	2012-08-10 00:05:23.000000000 -0700
@@ -69,6 +69,19 @@
 }
 
 /**
+ * chunks_read_cache(C, hash):
+ * Using the read cookie ${C}, tell the storage layer to cache the chunk with
+ * HMAC ${hash} after it is read.
+ */
+int
+chunks_read_cache(CHUNKS_R * C, const uint8_t * hash)
+{
+
+	/* Pass the message on to the storage layer. */
+	return (storage_read_cache(C->S, 'c', hash));
+}
+
+/**
  * chunks_read_chunk(C, hash, len, zlen, buf, quiet):
  * Using the read cookie ${C}, read the chunk with HMAC ${hash}
  * into ${buf}; it should have length ${len} and compressed size ${zlen}.
diff -ruN tarsnap-autoconf-1.0.32/tar/chunks/chunks_stats.c tarsnap-autoconf-1.0.33/tar/chunks/chunks_stats.c
--- tarsnap-autoconf-1.0.32/tar/chunks/chunks_stats.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/chunks/chunks_stats.c	2012-08-10 00:05:23.000000000 -0700
@@ -12,8 +12,8 @@
 #include "chunks.h"
 
 struct chunks_stats_internal {
-	RWHASHTAB * HT;		/* Hash table of struct chunkdata. */
-	struct chunkdata * dir;	/* On-disk directory entries. */
+	RWHASHTAB * HT;		/* Hash table of struct chunkdata_statstape. */
+	struct chunkdata_statstape * dir;	/* On-disk directory entries. */
 	char * cachepath;	/* Path to cache directory. */
 	struct chunkstats stats_total;	/* All archives, w/ multiplicity. */
 	struct chunkstats stats_unique;	/* All archives, w/o multiplicity. */
@@ -29,16 +29,17 @@
 
 /**
  * callback_zero(rec, cookie):
- * Mark the struct chunkdata ${rec} as being not used in the current archive.
+ * Mark the struct chunkdata_statstape ${rec} as being not used in the current
+ * archive.
  */
 static int
 callback_zero(void * rec, void * cookie)
 {
-	struct chunkdata * ch = rec;
+	struct chunkdata_statstape * ch = rec;
 
 	(void)cookie;	/* UNUSED */
 
-	ch->flags &= ~CHDATA_CTAPE;
+	ch->d.zlen_flags &= ~CHDATA_CTAPE;
 	ch->ncopies_ctape = 0;
 
 	/* Success! */
@@ -52,13 +53,13 @@
 static int
 callback_add(void * rec, void * cookie)
 {
-	struct chunkdata * ch = rec;
+	struct chunkdata_statstape * ch = rec;
 
 	(void)cookie;	/* UNUSED */
 
-	ch->ncopies += ch->ncopies_ctape;
-	if (ch->flags & CHDATA_CTAPE)
-		ch->nrefs += 1;
+	ch->d.ncopies += ch->ncopies_ctape;
+	if (ch->d.zlen_flags & CHDATA_CTAPE)
+		ch->d.nrefs += 1;
 
 	/* Success! */
 	return (0);
@@ -66,22 +67,22 @@
 
 /**
  * callback_delete(rec, cookie):
- * If the reference count of the struct chunkdata ${rec} is zero, delete
- * the chunk using the storage layer delete cookie ${cookie}.
+ * If the reference count of the struct chunkdata_statstape ${rec} is zero,
+ * delete the chunk using the storage layer delete cookie ${cookie}.
  */
 static int
 callback_delete(void * rec, void * cookie)
 {
-	struct chunkdata * ch = rec;
+	struct chunkdata_statstape * ch = rec;
 	STORAGE_D * S = cookie;
 	char hashbuf[65];
 
-	if (ch->nrefs)
+	if (ch->d.nrefs)
 		goto done;
 
-	hexify(ch->hash, hashbuf, 32);
+	hexify(ch->d.hash, hashbuf, 32);
 	fprintf(stdout, "  Removing unreferenced chunk file: %s\n", hashbuf);
-	if (storage_delete_file(S, 'c', ch->hash))
+	if (storage_delete_file(S, 'c', ch->d.hash))
 		goto err0;
 
 done:
@@ -119,21 +120,21 @@
 	if (storage_directory_read(machinenum, 'c', 0, &flist, &nfiles))
 		goto err2;
 
-	/* Construct a chunkdata structure for each file. */
-	if (nfiles > SIZE_MAX / sizeof(struct chunkdata)) {
+	/* Construct a chunkdata_statstape structure for each file. */
+	if (nfiles > SIZE_MAX / sizeof(struct chunkdata_statstape)) {
 		errno = ENOMEM;
 		free(flist);
 		goto err2;
 	}
-	if ((C->dir = malloc(nfiles * sizeof(struct chunkdata))) == NULL) {
+	if ((C->dir =
+	    malloc(nfiles * sizeof(struct chunkdata_statstape))) == NULL) {
 		free(flist);
 		goto err2;
 	}
 	for (file = 0; file < nfiles; file++) {
-		memcpy(C->dir[file].hash, &flist[file * 32], 32);
-		C->dir[file].len = C->dir[file].zlen = 0;
-		C->dir[file].nrefs = C->dir[file].ncopies = 0;
-		C->dir[file].flags = 0;
+		memcpy(C->dir[file].d.hash, &flist[file * 32], 32);
+		C->dir[file].d.len = C->dir[file].d.zlen_flags = 0;
+		C->dir[file].d.nrefs = C->dir[file].d.ncopies = 0;
 	}
 
 	/* Free the file list. */
@@ -232,6 +233,7 @@
 chunks_stats_init(const char * cachepath)
 {
 	struct chunks_stats_internal * C;
+	void * dir;
 
 	/* Allocate memory. */
 	if ((C = malloc(sizeof(struct chunks_stats_internal))) == NULL)
@@ -242,9 +244,10 @@
 		goto err1;
 
 	/* Read directory. */
-	if ((C->HT = chunks_directory_read(cachepath, &C->dir,
-	    &C->stats_unique, &C->stats_total, &C->stats_extra, 1)) == NULL)
+	if ((C->HT = chunks_directory_read(cachepath, &dir,
+	    &C->stats_unique, &C->stats_total, &C->stats_extra, 1, 1)) == NULL)
 		goto err2;
+	C->dir = dir;
 
 	/* Success! */
 	return (C);
@@ -259,6 +262,18 @@
 }
 
 /**
+ * chunks_stats_getdirsz(C):
+ * Return the number of entries in the chunks directory associated with ${C}.
+ */
+size_t
+chunks_stats_getdirsz(CHUNKS_S * C)
+{
+
+	/* Get the value from the hash table. */
+	return (rwhashtab_getsize(C->HT));
+}
+
+/**
  * chunks_stats_printglobal(stream, C):
  * Print global statistics relating to a set of archives.
  */
@@ -312,28 +327,28 @@
 chunks_stats_addchunk(CHUNKS_S * C, const uint8_t * hash,
     size_t len, size_t zlen)
 {
-	struct chunkdata * ch;
+	struct chunkdata_statstape * ch;
 
 	/* If the chunk is not in ${S}->HT, error out. */
 	if ((ch = rwhashtab_read(C->HT, hash)) == NULL)
 		goto notpresent;
 
 	/* Record the lengths if necessary. */
-	if (ch->nrefs == 0 && ch->ncopies_ctape == 0) {
-		ch->len = len;
-		ch->zlen = zlen;
+	if (ch->d.nrefs == 0 && ch->ncopies_ctape == 0) {
+		ch->d.len = len;
+		ch->d.zlen_flags = zlen | (ch->d.zlen_flags & CHDATA_FLAGS);
 	}
 
 	/* Update "current tape" statistics. */
 	chunks_stats_add(&C->stats_tape, len, zlen, 1);
 
 	/* Update "data unique to this archive" statistics. */
-	if ((ch->nrefs <= 1) && ((ch->flags & CHDATA_CTAPE) == 0))
+	if ((ch->d.nrefs <= 1) && ((ch->d.zlen_flags & CHDATA_CTAPE) == 0))
 		chunks_stats_add(&C->stats_tapeu, len, zlen, 1);
 
 	/* Chunk is in current archive. */
 	ch->ncopies_ctape += 1;
-	ch->flags |= CHDATA_CTAPE;
+	ch->d.zlen_flags |= CHDATA_CTAPE;
 
 	/* Success! */
 	return (0);
diff -ruN tarsnap-autoconf-1.0.32/tar/chunks/chunks_write.c tarsnap-autoconf-1.0.33/tar/chunks/chunks_write.c
--- tarsnap-autoconf-1.0.32/tar/chunks/chunks_write.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/chunks/chunks_write.c	2012-08-10 00:05:23.000000000 -0700
@@ -19,7 +19,7 @@
 	uint8_t * zbuf;			/* Buffer for compression. */
 	size_t zbuflen;			/* Length of zbuf. */
 	RWHASHTAB * HT;			/* Hash table of struct chunkdata. */
-	struct chunkdata * dir;		/* On-disk directory entries. */
+	void * dir;			/* On-disk directory entries. */
 	char * path;			/* Path to cache directory. */
 	STORAGE_W * S;			/* Storage layer cookie. */
 	int dryrun;			/* Nonzero if this is a dry run. */
@@ -73,7 +73,7 @@
 
 	/* Read the existing chunk directory (if one exists). */
 	if ((C->HT = chunks_directory_read(cachepath, &C->dir,
-	    &C->stats_unique, &C->stats_total, &C->stats_extra, 0)) == NULL)
+	    &C->stats_unique, &C->stats_total, &C->stats_extra, 0, 0)) == NULL)
 		goto err3;
 
 	/* Zero "new chunks" and "this tape" statistics. */
@@ -113,14 +113,16 @@
 
 	/* If the chunk is in ${C}->HT, return the compressed length. */
 	if ((ch = rwhashtab_read(C->HT, hash)) != NULL) {
-		chunks_stats_add(&C->stats_total, ch->len, ch->zlen, 1);
-		chunks_stats_add(&C->stats_tape, ch->len, ch->zlen, 1);
+		chunks_stats_add(&C->stats_total, ch->len,
+		    ch->zlen_flags & CHDATA_ZLEN, 1);
+		chunks_stats_add(&C->stats_tape, ch->len,
+		    ch->zlen_flags & CHDATA_ZLEN, 1);
 		ch->ncopies += 1;
-		if ((ch->flags & CHDATA_CTAPE) == 0) {
+		if ((ch->zlen_flags & CHDATA_CTAPE) == 0) {
 			ch->nrefs += 1;
-			ch->flags |= CHDATA_CTAPE;
+			ch->zlen_flags |= CHDATA_CTAPE;
 		}
-		return (ch->zlen);
+		return (ch->zlen_flags & CHDATA_ZLEN);
 	}
 
 	/* Compress the chunk. */
@@ -157,20 +159,19 @@
 	/* ... fill in the chunk parameters... */
 	memcpy(ch->hash, hash, 32);
 	ch->len = buflen;
-	ch->zlen = zlen;
+	ch->zlen_flags = zlen | CHDATA_MALLOC | CHDATA_CTAPE;
 	ch->nrefs = 1;
 	ch->ncopies = 1;
-	ch->flags = CHDATA_MALLOC | CHDATA_CTAPE;
 
 	/* ... and insert it into the hash table. */
 	if (rwhashtab_insert(C->HT, ch))
 		goto err0;
 
 	/* Update statistics. */
-	chunks_stats_add(&C->stats_total, ch->len, ch->zlen, 1);
-	chunks_stats_add(&C->stats_unique, ch->len, ch->zlen, 1);
-	chunks_stats_add(&C->stats_tape, ch->len, ch->zlen, 1);
-	chunks_stats_add(&C->stats_new, ch->len, ch->zlen, 1);
+	chunks_stats_add(&C->stats_total, ch->len, zlen, 1);
+	chunks_stats_add(&C->stats_unique, ch->len, zlen, 1);
+	chunks_stats_add(&C->stats_tape, ch->len, zlen, 1);
+	chunks_stats_add(&C->stats_new, ch->len, zlen, 1);
 
 	/* Success! */
 	return (zlen);
@@ -210,12 +211,14 @@
 	 * transaction and return 0.
 	 */
 	if ((ch = rwhashtab_read(C->HT, hash)) != NULL) {
-		chunks_stats_add(&C->stats_total, ch->len, ch->zlen, 1);
-		chunks_stats_add(&C->stats_tape, ch->len, ch->zlen, 1);
+		chunks_stats_add(&C->stats_total, ch->len,
+		    ch->zlen_flags & CHDATA_ZLEN, 1);
+		chunks_stats_add(&C->stats_tape, ch->len,
+		    ch->zlen_flags & CHDATA_ZLEN, 1);
 		ch->ncopies += 1;
-		if ((ch->flags & CHDATA_CTAPE) == 0) {
+		if ((ch->zlen_flags & CHDATA_CTAPE) == 0) {
 			ch->nrefs += 1;
-			ch->flags |= CHDATA_CTAPE;
+			ch->zlen_flags |= CHDATA_CTAPE;
 		}
 
 		return (0);
diff -ruN tarsnap-autoconf-1.0.32/tar/glue/tape.c tarsnap-autoconf-1.0.33/tar/glue/tape.c
--- tarsnap-autoconf-1.0.32/tar/glue/tape.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/glue/tape.c	2012-08-10 00:05:23.000000000 -0700
@@ -16,19 +16,34 @@
 void
 tarsnap_mode_d(struct bsdtar *bsdtar)
 {
+	TAPE_D * d;
 	size_t i;
 
+	/* Prepare for deletes. */
+	if ((d = deletetape_init(bsdtar->machinenum)) == NULL)
+		goto err1;
+
+	/* Delete archives. */
 	for (i = 0; i < bsdtar->ntapes; i++) {
 		if (bsdtar->verbose && (bsdtar->ntapes > 1))
 			fprintf(stderr, "Deleting archive \"%s\"\n",
 			    bsdtar->tapenames[i]);
-		if (deletetape(bsdtar->machinenum, bsdtar->cachedir,
+		if (deletetape(d, bsdtar->machinenum, bsdtar->cachedir,
 		    bsdtar->tapenames[i], bsdtar->option_print_stats,
-		    bsdtar->ntapes > 1 ? 1 : 0)) {
-			bsdtar_warnc(bsdtar, 0, "Error deleting archive");
-			exit(1);
-		}
+		    bsdtar->ntapes > 1 ? 1 : 0))
+			goto err1;
 	}
+
+	/* We've finished deleting archives. */
+	deletetape_free(d);
+
+	/* Success! */
+	return;
+
+err1:
+	/* Failure! */
+	bsdtar_warnc(bsdtar, 0, "Error deleting archive");
+	exit(1);
 }
 
 /*
diff -ruN tarsnap-autoconf-1.0.32/tar/multitape/multitape.h tarsnap-autoconf-1.0.33/tar/multitape/multitape.h
--- tarsnap-autoconf-1.0.32/tar/multitape/multitape.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/multitape/multitape.h	2012-08-10 00:05:23.000000000 -0700
@@ -7,6 +7,7 @@
 
 typedef struct multitape_read_internal TAPE_R;
 typedef struct multitape_write_internal TAPE_W;
+typedef struct multitape_delete_internal TAPE_D;
 typedef struct multitape_stats_internal TAPE_S;
 
 struct chunkheader;
@@ -124,12 +125,24 @@
 void writetape_free(TAPE_W *);
 
 /**
- * deletetape(machinenum, cachedir, tapename, printstats, withname):
+ * deletetape_init(machinenum):
+ * Return a cookie which can be passed to deletetape.
+ */
+TAPE_D * deletetape_init(uint64_t);
+
+/**
+ * deletetape(d, machinenum, cachedir, tapename, printstats, withname):
  * Delete the specified tape, and print statistics to stderr if requested.
  * If ${withname} is non-zero, print statistics with the archive name, not
  * just as "This archive".
  */
-int deletetape(uint64_t, const char *, const char *, int, int);
+int deletetape(TAPE_D *, uint64_t, const char *, const char *, int, int);
+
+/**
+ * deletetape_free(d):
+ * Free the delete cookie ${d}.
+ */
+void deletetape_free(TAPE_D *);
 
 /**
  * statstape_open(machinenum, cachedir):
diff -ruN tarsnap-autoconf-1.0.32/tar/multitape/multitape_chunkiter.c tarsnap-autoconf-1.0.33/tar/multitape/multitape_chunkiter.c
--- tarsnap-autoconf-1.0.32/tar/multitape/multitape_chunkiter.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/multitape/multitape_chunkiter.c	2012-08-10 00:05:23.000000000 -0700
@@ -91,6 +91,10 @@
 			goto err3;
 		}
 
+		/* We want to cache this chunk after reading it. */
+		if (chunks_read_cache(CR, ch->hash))
+			goto err2;
+
 		/* Read the chunk into buffer. */
 		if ((rc = chunks_read_chunk(CR, ch->hash, chunklen, chunkzlen,
 		    ibuf + ibuflen, quiet)) != 0)
diff -ruN tarsnap-autoconf-1.0.32/tar/multitape/multitape_delete.c tarsnap-autoconf-1.0.33/tar/multitape/multitape_delete.c
--- tarsnap-autoconf-1.0.32/tar/multitape/multitape_delete.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/multitape/multitape_delete.c	2012-08-10 00:05:23.000000000 -0700
@@ -1,6 +1,7 @@
 #include "bsdtar_platform.h"
 
 #include <stdint.h>
+#include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
 
@@ -11,6 +12,11 @@
 
 #include "multitape.h"
 
+/* Cookie created by deletetape_init and passed to other functions. */
+struct multitape_delete_internal {
+	STORAGE_R * S;	/* Storage read cookie. */
+};
+
 static int callback_delete(void *, struct chunkheader *);
 
 /**
@@ -27,19 +33,46 @@
 }
 
 /**
- * deletetape(machinenum, cachedir, tapename, printstats, withname):
+ * deletetape_init(machinenum):
+ * Return a cookie which can be passed to deletetape.
+ */
+TAPE_D *
+deletetape_init(uint64_t machinenum)
+{
+	struct multitape_delete_internal * d;
+
+	/* Allocate memory. */
+	if ((d = malloc(sizeof(struct multitape_delete_internal))) == NULL)
+		goto err0;
+
+	/* Obtain a storage layer read cookie. */
+	if ((d->S = storage_read_init(machinenum)) == NULL)
+		goto err1;
+
+	/* Success! */
+	return (d);
+
+err1:
+	free(d);
+err0:
+	/* Failure!  */
+	return (NULL);
+}
+
+/**
+ * deletetape(d, machinenum, cachedir, tapename, printstats, withname):
  * Delete the specified tape, and print statistics to stderr if requested.
  * If ${withname} is non-zero, print statistics with the archive name, not
  * just as "This archive".
  */
 int
-deletetape(uint64_t machinenum, const char * cachedir,
+deletetape(TAPE_D * d, uint64_t machinenum, const char * cachedir,
     const char * tapename, int printstats, int withname)
 {
 	struct tapemetadata tmd;
 	CHUNKS_D * C;		/* Chunk layer delete cookie. */
 	STORAGE_D * S;		/* Storage layer delete cookie. */
-	STORAGE_R * SR;		/* Storage layer read cookie. */
+	STORAGE_R * SR = d->S;		/* Storage layer read cookie. */
 	int lockfd;
 	uint8_t lastseq[32];
 	uint8_t seqnum[32];
@@ -59,43 +92,43 @@
 	/* Obtain storage and chunk layer cookies. */
 	if ((S = storage_delete_start(machinenum, lastseq, seqnum)) == NULL)
 		goto err1;
-	if ((SR = storage_read_init(machinenum)) == NULL)
-		goto err2;
 	if ((C = chunks_delete_start(cachedir, S)) == NULL)
-		goto err3;
+		goto err2;
+
+	/* Cache up to 100 bytes of blocks per chunk in the directory. */
+	storage_read_cache_limit(SR, 100 * chunks_delete_getdirsz(C));
 
 	/* Read archive metadata. */
 	if (multitape_metadata_get_byname(SR, NULL, &tmd, tapename, 0))
-		goto err4;
+		goto err3;
 
 	/* Delete chunks. */
 	if (multitape_chunkiter_tmd(SR, NULL, &tmd, callback_delete, C, 0))
-		goto err5;
+		goto err4;
 
 	/* Delete archive index. */
 	if (multitape_metaindex_delete(S, C, &tmd))
-		goto err5;
+		goto err4;
 
 	/* Delete archive metadata. */
 	if (multitape_metadata_delete(S, C, &tmd))
-		goto err5;
+		goto err4;
 
 	/* Free tape metadata. */
 	multitape_metadata_free(&tmd);
 
 	/* Ask the storage layer to flush all pending deletes. */
 	if (storage_delete_flush(S))
-		goto err4;
+		goto err3;
 
 	/* Print statistics if they were requested. */
 	if ((printstats != 0) &&
 	    chunks_delete_printstats(stderr, C, withname ? tapename : NULL))
-		goto err4;
+		goto err3;
 
 	/* Close storage and chunk layer cookies. */
 	if (chunks_delete_end(C))
-		goto err3;
-	storage_read_free(SR);
+		goto err2;
 	if (storage_delete_end(S))
 		goto err1;
 
@@ -109,12 +142,10 @@
 	/* Success! */
 	return (0);
 
-err5:
-	multitape_metadata_free(&tmd);
 err4:
-	chunks_delete_free(C);
+	multitape_metadata_free(&tmd);
 err3:
-	storage_read_free(SR);
+	chunks_delete_free(C);
 err2:
 	storage_delete_free(S);
 err1:
@@ -123,3 +154,18 @@
 	/* Failure! */
 	return (-1);
 }
+
+/**
+ * deletetape_free(d):
+ * Free the delete cookie ${d}.
+ */
+void
+deletetape_free(TAPE_D * d)
+{
+
+	/* Close the storage layer read cookie. */
+	storage_read_free(d->S);
+
+	/* Free the multitape layer delete cookie. */
+	free(d);
+}
diff -ruN tarsnap-autoconf-1.0.32/tar/multitape/multitape_fsck.c tarsnap-autoconf-1.0.33/tar/multitape/multitape_fsck.c
--- tarsnap-autoconf-1.0.32/tar/multitape/multitape_fsck.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/multitape/multitape_fsck.c	2012-08-10 00:05:23.000000000 -0700
@@ -370,6 +370,9 @@
 	/* Report status. */
 	fprintf(stdout, "Phase 4: Verifying archive completeness\n");
 
+	/* Cache up to 100 bytes of blocks per chunk in the directory. */
+	storage_read_cache_limit(SR, 100 * chunks_stats_getdirsz(C));
+
 	/* Iterate through the archives. */
 	for (file = 0; file < nmdat; file++) {
 		/* Print progress. */
diff -ruN tarsnap-autoconf-1.0.32/tar/multitape/multitape_stats.c tarsnap-autoconf-1.0.33/tar/multitape/multitape_stats.c
--- tarsnap-autoconf-1.0.32/tar/multitape/multitape_stats.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/multitape/multitape_stats.c	2012-08-10 00:05:23.000000000 -0700
@@ -126,6 +126,9 @@
 	if (storage_directory_read(d->machinenum, 'm', 0, &flist, &nfiles))
 		goto err0;
 
+	/* Cache up to 100 bytes of blocks per chunk in the directory. */
+	storage_read_cache_limit(d->SR, 100 * chunks_stats_getdirsz(d->C));
+
 	/* Iterate through the files. */
 	for (file = 0; file < nfiles; file++) {
 		/* Zero archive statistics. */
@@ -260,6 +263,9 @@
 {
 	struct tapemetadata tmd;
 
+	/* Cache up to 100 bytes of blocks per chunk in the directory. */
+	storage_read_cache_limit(d->SR, 100 * chunks_stats_getdirsz(d->C));
+
 	/* Zero archive statistics. */
 	chunks_stats_zeroarchive(d->C);
 
diff -ruN tarsnap-autoconf-1.0.32/tar/storage/storage.h tarsnap-autoconf-1.0.33/tar/storage/storage.h
--- tarsnap-autoconf-1.0.32/tar/storage/storage.h	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/storage/storage.h	2012-08-10 00:05:23.000000000 -0700
@@ -20,6 +20,21 @@
 STORAGE_R * storage_read_init(uint64_t);
 
 /**
+ * storage_read_cache(S, class, name):
+ * Add the file ${name} from class ${class} into the cache for the read cookie
+ * ${S} returned from storage_read_init.  The data will not be fetched yet;
+ * but any future fetch will look in the cache first and will store the block
+ * in the cache if it needs to be fetched.
+ */
+int storage_read_cache(STORAGE_R *, char, const uint8_t[32]);
+
+/**
+ * storage_read_cache_limit(S, size):
+ * Set a limit of ${size} bytes on the cache associated with read cookie {S}.
+ */
+void storage_read_cache_limit(STORAGE_R *, size_t);
+
+/**
  * storage_read_file(S, buf, buflen, class, name):
  * Read the file ${name} from class ${class} using the read cookie ${S}
  * returned from storage_read_init into the buffer ${buf} of length ${buflen}.
